//+------------------------------------------------------------------+
//|                                                       iPower.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window

#property indicator_buffers   1
#property indicator_color1    Silver
#property indicator_width1    2
#property indicator_minimum   0

extern int Power=0;

double BUFFER[];

bool EQ(int value1,int value2)
{
   return(value1==value2);
}

int SUM(double price)
{
   string P=DoubleToStr(price,Digits);
   int S=0;
   for(int i=0; i<StringLen(P); i++) S+=StrToInteger(StringSubstr(P,i,1));
   return(S);
}

int POWER(int shift)
{
   return(SUM(Open[shift])+SUM(High[shift])+SUM(Low[shift])+SUM(Close[shift]));
}

bool BARS(int index)
{
   return(index<Bars-IndicatorCounted());
}

void DRAW(int shift)
{   
   int P=POWER(shift);
   if(Power<1)      
      BUFFER[shift]=P; else
   if(EQ(Power,P))
      BUFFER[shift]=P; else BUFFER[shift]=0;
}

void start()
{
   for(int i=0; BARS(i); i++) DRAW(i);
}
  
void init()
{
   IndicatorBuffers(1);
   SetIndexBuffer(0,BUFFER);
   SetIndexStyle(0,DRAW_HISTOGRAM); 
   IndicatorDigits(0);
   IndicatorShortName("iPower");    
}

